> For the complete documentation index, see [llms.txt](https://developer.harness.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://developer.harness.io/api-reference/software-delivery-agent-apis/gitops/rollouts.md).

# Rollouts

## GET /api/v1/agents/{agentIdentifier}/applications/{request.name}/rollouts/status

> Get current status for the given Rollout resource

````json
{"openapi":"3.0.0","info":{"title":"Harness NextGen GitOps API Reference","version":"1.0"},"paths":{"/api/v1/agents/{agentIdentifier}/applications/{request.name}/rollouts/status":{"get":{"description":"Get current status for the given Rollout resource","operationId":"RolloutsService_GetRolloutStatus","responses":{"200":{"description":"A successful response.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/v1RolloutInfo"}}}},"default":{"description":"An unexpected error response.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/gatewayruntimeError"}}}}},"parameters":[{"name":"agentIdentifier","description":"Agent identifier for entity.","in":"path","required":true,"schema":{"type":"string"}},{"name":"request.name","in":"path","required":true,"schema":{"type":"string"}},{"name":"accountIdentifier","description":"Account Identifier for the Entity.","in":"query","required":false,"schema":{"type":"string"}},{"name":"orgIdentifier","description":"Organization Identifier for the Entity.","in":"query","required":false,"schema":{"type":"string"}},{"name":"projectIdentifier","description":"Project Identifier for the Entity.","in":"query","required":false,"schema":{"type":"string"}},{"name":"request.namespace","in":"query","required":false,"schema":{"type":"string"}},{"name":"request.resourceName","in":"query","required":false,"schema":{"type":"string"}},{"name":"request.version","in":"query","required":false,"schema":{"type":"string"}},{"name":"request.group","in":"query","required":false,"schema":{"type":"string"}},{"name":"request.kind","in":"query","required":false,"schema":{"type":"string"}},{"name":"request.appNamespace","in":"query","required":false,"schema":{"type":"string"}},{"name":"request.project","in":"query","required":false,"schema":{"type":"string"}}],"tags":["Rollouts"]}}},"components":{"schemas":{"v1RolloutInfo":{"type":"object","properties":{"metadata":{"$ref":"#/components/schemas/v1ObjectMeta"},"status":{"type":"string"},"message":{"type":"string"},"icon":{"type":"string"},"strategy":{"type":"string"},"step":{"type":"string"},"setWeight":{"type":"string"},"actualWeight":{"type":"string"},"ready":{"type":"integer","format":"int32"},"current":{"type":"integer","format":"int32"},"desired":{"type":"integer","format":"int32"},"updated":{"type":"integer","format":"int32"},"available":{"type":"integer","format":"int32"},"restartedAt":{"type":"string"},"generation":{"type":"string"},"replicaSets":{"type":"array","items":{"$ref":"#/components/schemas/v1RolloutReplicaSetInfo"}},"experiments":{"type":"array","items":{"$ref":"#/components/schemas/v1RolloutExperimentInfo"}},"analysisRuns":{"type":"array","items":{"$ref":"#/components/schemas/v1RolloutAnalysisRunInfo"}},"containers":{"type":"array","items":{"$ref":"#/components/schemas/v1RolloutContainerInfo"}},"steps":{"type":"array","items":{"$ref":"#/components/schemas/v1CanaryStep"}},"canaryRevision":{"type":"integer","format":"int32"},"canaryImages":{"type":"array","items":{"type":"string"}},"previewImages":{"type":"array","items":{"type":"string"}},"stableImages":{"type":"array","items":{"type":"string"}},"isManualPause":{"type":"boolean"}}},"v1ObjectMeta":{"type":"object","properties":{"name":{"type":"string","title":"Name must be unique within a namespace. Is required when creating resources, although\nsome resources may allow a client to request the generation of an appropriate name\nautomatically. Name is primarily intended for creation idempotence and configuration\ndefinition.\nCannot be updated.\nMore info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names#names\n+optional"},"generateName":{"type":"string","description":"GenerateName is an optional prefix, used by the server, to generate a unique\nname ONLY IF the Name field has not been provided.\nIf this field is used, the name returned to the client will be different\nthan the name passed. This value will also be combined with a unique suffix.\nThe provided value has the same validation rules as the Name field,\nand may be truncated by the length of the suffix required to make the value\nunique on the server.\n\nIf this field is specified and the generated name exists, the server will return a 409.\n\nApplied only if Name is not specified.\nMore info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#idempotency\n+optional"},"namespace":{"type":"string","description":"Namespace defines the space within which each name must be unique. An empty namespace is\nequivalent to the \"default\" namespace, but \"default\" is the canonical representation.\nNot all objects are required to be scoped to a namespace - the value of this field for\nthose objects will be empty.\n\nMust be a DNS_LABEL.\nCannot be updated.\nMore info: https://kubernetes.io/docs/concepts/overview/working-with-objects/namespaces\n+optional"},"selfLink":{"type":"string","title":"Deprecated: selfLink is a legacy read-only field that is no longer populated by the system.\n+optional"},"uid":{"type":"string","description":"UID is the unique in time and space value for this object. It is typically generated by\nthe server on successful creation of a resource and is not allowed to change on PUT\noperations.\n\nPopulated by the system.\nRead-only.\nMore info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names#uids\n+optional"},"resourceVersion":{"type":"string","description":"An opaque value that represents the internal version of this object that can\nbe used by clients to determine when objects have changed. May be used for optimistic\nconcurrency, change detection, and the watch operation on a resource or set of resources.\nClients must treat these values as opaque and passed unmodified back to the server.\nThey may only be valid for a particular resource or set of resources.\n\nPopulated by the system.\nRead-only.\nValue must be treated as opaque by clients and .\nMore info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#concurrency-control-and-consistency\n+optional"},"generation":{"type":"string","format":"int64","title":"A sequence number representing a specific generation of the desired state.\nPopulated by the system. Read-only.\n+optional"},"creationTimestamp":{"$ref":"#/components/schemas/v1Time"},"deletionTimestamp":{"$ref":"#/components/schemas/v1Time"},"deletionGracePeriodSeconds":{"type":"string","format":"int64","title":"Number of seconds allowed for this object to gracefully terminate before\nit will be removed from the system. Only set when deletionTimestamp is also set.\nMay only be shortened.\nRead-only.\n+optional"},"labels":{"type":"object","additionalProperties":{"type":"string"},"title":"Map of string keys and values that can be used to organize and categorize\n(scope and select) objects. May match selectors of replication controllers\nand services.\nMore info: https://kubernetes.io/docs/concepts/overview/working-with-objects/labels\n+optional"},"annotations":{"type":"object","additionalProperties":{"type":"string"},"title":"Annotations is an unstructured key value map stored with a resource that may be\nset by external tools to store and retrieve arbitrary metadata. They are not\nqueryable and should be preserved when modifying objects.\nMore info: https://kubernetes.io/docs/concepts/overview/working-with-objects/annotations\n+optional"},"ownerReferences":{"type":"array","items":{"$ref":"#/components/schemas/v1OwnerReference"},"title":"List of objects depended by this object. If ALL objects in the list have\nbeen deleted, this object will be garbage collected. If this object is managed by a controller,\nthen an entry in this list will point to this controller, with the controller field set to true.\nThere cannot be more than one managing controller.\n+optional\n+patchMergeKey=uid\n+patchStrategy=merge\n+listType=map\n+listMapKey=uid"},"finalizers":{"type":"array","items":{"type":"string"},"title":"Must be empty before the object is deleted from the registry. Each entry\nis an identifier for the responsible component that will remove the entry\nfrom the list. If the deletionTimestamp of the object is non-nil, entries\nin this list can only be removed.\nFinalizers may be processed and removed in any order.  Order is NOT enforced\nbecause it introduces significant risk of stuck finalizers.\nfinalizers is a shared field, any actor with permission can reorder it.\nIf the finalizer list is processed in order, then this can lead to a situation\nin which the component responsible for the first finalizer in the list is\nwaiting for a signal (field value, external system, or other) produced by a\ncomponent responsible for a finalizer later in the list, resulting in a deadlock.\nWithout enforced ordering finalizers are free to order amongst themselves and\nare not vulnerable to ordering changes in the list.\n+optional\n+patchStrategy=merge\n+listType=set"},"managedFields":{"type":"array","items":{"$ref":"#/components/schemas/v1ManagedFieldsEntry"},"description":"ManagedFields maps workflow-id and version to the set of fields\nthat are managed by that workflow. This is mostly for internal\nhousekeeping, and users typically shouldn't need to set or\nunderstand this field. A workflow can be the user's name, a\ncontroller's name, or the name of a specific apply path like\n\"ci-cd\". The set of fields is always in the version that the\nworkflow used when modifying the object.\n\n+optional\n+listType=atomic"}},"description":"ObjectMeta is metadata that all persisted resources must have, which includes all objects\nusers must create."},"v1Time":{"type":"object","properties":{"seconds":{"type":"string","format":"int64","description":"Represents seconds of UTC time since Unix epoch\n1970-01-01T00:00:00Z. Must be from 0001-01-01T00:00:00Z to\n9999-12-31T23:59:59Z inclusive."},"nanos":{"type":"integer","format":"int32","description":"Non-negative fractions of a second at nanosecond resolution. Negative\nsecond values with fractions must still have non-negative nanos values\nthat count forward in time. Must be from 0 to 999,999,999\ninclusive. This field may be limited in precision depending on context."}},"description":"Time is a wrapper around time.Time which supports correct\nmarshaling to YAML and JSON.  Wrappers are provided for many\nof the factory methods that the time package offers.\n\n+protobuf.options.marshal=false\n+protobuf.as=Timestamp\n+protobuf.options.(gogoproto.goproto_stringer)=false"},"v1OwnerReference":{"type":"object","properties":{"apiVersion":{"type":"string","description":"API version of the referent."},"kind":{"type":"string","title":"Kind of the referent.\nMore info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds"},"name":{"type":"string","title":"Name of the referent.\nMore info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names#names"},"uid":{"type":"string","title":"UID of the referent.\nMore info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names#uids"},"controller":{"type":"boolean","title":"If true, this reference points to the managing controller.\n+optional"},"blockOwnerDeletion":{"type":"boolean","title":"If true, AND if the owner has the \"foregroundDeletion\" finalizer, then\nthe owner cannot be deleted from the key-value store until this\nreference is removed.\nSee https://kubernetes.io/docs/concepts/architecture/garbage-collection/#foreground-deletion\nfor how the garbage collector interacts with this field and enforces the foreground deletion.\nDefaults to false.\nTo set this field, a user needs \"delete\" permission of the owner,\notherwise 422 (Unprocessable Entity) will be returned.\n+optional"}},"title":"OwnerReference contains enough information to let you identify an owning\nobject. An owning object must be in the same namespace as the dependent, or\nbe cluster-scoped, so there is no namespace field.\n+structType=atomic"},"v1ManagedFieldsEntry":{"type":"object","properties":{"manager":{"type":"string","description":"Manager is an identifier of the workflow managing these fields."},"operation":{"type":"string","description":"Operation is the type of operation which lead to this ManagedFieldsEntry being created.\nThe only valid values for this field are 'Apply' and 'Update'."},"apiVersion":{"type":"string","description":"APIVersion defines the version of this resource that this field set\napplies to. The format is \"group/version\" just like the top-level\nAPIVersion field. It is necessary to track the version of a field\nset because it cannot be automatically converted."},"time":{"$ref":"#/components/schemas/v1Time"},"fieldsType":{"type":"string","title":"FieldsType is the discriminator for the different fields format and version.\nThere is currently only one possible value: \"FieldsV1\""},"fieldsV1":{"$ref":"#/components/schemas/v1FieldsV1"},"subresource":{"type":"string","description":"Subresource is the name of the subresource used to update that object, or\nempty string if the object was updated through the main resource. The\nvalue of this field is used to distinguish between managers, even if they\nshare the same name. For example, a status update will be distinct from a\nregular update using the same manager name.\nNote that the APIVersion field is not related to the Subresource field and\nit always corresponds to the version of the main resource."}},"description":"ManagedFieldsEntry is a workflow-id, a FieldSet and the group version of the resource\nthat the fieldset applies to."},"v1FieldsV1":{"type":"object","properties":{"Raw":{"type":"string","format":"byte","description":"Raw is the underlying serialization of this object.\n\nDeprecated: Direct access to this field is deprecated. Use GetRawBytes, GetRawString, SetRawBytes, SetRawString, GetRawReader, NewFieldsV1 instead."}},"description":"FieldsV1 stores a set of fields in a data structure like a Trie, in JSON format.\n\nEach key is either a '.' representing the field itself, and will always map to an empty set,\nor a string representing a sub-field or item. The string will follow one of these four formats:\n'f:<name>', where <name> is the name of a field in a struct, or key in a map\n'v:<value>', where <value> is the exact json formatted value of a list item\n'i:<index>', where <index> is position of a item in a list\n'k:<keys>', where <keys> is a map of  a list item's key fields to their unique values\nIf a key maps to an empty Fields value, the field that key represents is part of the set.\n\nThe exact format is defined in sigs.k8s.io/structured-merge-diff\n+k8s:deepcopy-gen=false\n+protobuf.options.marshal=false\n+protobuf.options.(gogoproto.goproto_stringer)=false"},"v1RolloutReplicaSetInfo":{"type":"object","properties":{"metadata":{"$ref":"#/components/schemas/v1ObjectMeta"},"status":{"type":"string"},"icon":{"type":"string"},"revision":{"type":"string"},"stable":{"type":"boolean"},"canary":{"type":"boolean"},"active":{"type":"boolean"},"preview":{"type":"boolean"},"replicas":{"type":"integer","format":"int32"},"available":{"type":"integer","format":"int32"},"template":{"type":"string"},"scaleDownDeadline":{"type":"string"},"images":{"type":"array","items":{"type":"string"}},"pods":{"type":"array","items":{"$ref":"#/components/schemas/v1RolloutPodInfo"}},"ping":{"type":"boolean"},"pong":{"type":"boolean"}}},"v1RolloutPodInfo":{"type":"object","properties":{"metadata":{"$ref":"#/components/schemas/v1ObjectMeta"},"status":{"type":"string"},"icon":{"type":"string"},"ready":{"type":"string"},"restarts":{"type":"integer","format":"int32"}}},"v1RolloutExperimentInfo":{"type":"object","properties":{"metadata":{"$ref":"#/components/schemas/v1ObjectMeta"},"icon":{"type":"string"},"revision":{"type":"string"},"status":{"type":"string"},"message":{"type":"string"},"replicaSets":{"type":"array","items":{"$ref":"#/components/schemas/v1RolloutReplicaSetInfo"}},"analysisRuns":{"type":"array","items":{"$ref":"#/components/schemas/v1RolloutAnalysisRunInfo"}}}},"v1RolloutAnalysisRunInfo":{"type":"object","properties":{"metadata":{"$ref":"#/components/schemas/v1ObjectMeta"},"icon":{"type":"string"},"revision":{"type":"string"},"status":{"type":"string"},"successful":{"type":"integer","format":"int32"},"failed":{"type":"integer","format":"int32"},"inconclusive":{"type":"integer","format":"int32"},"error":{"type":"integer","format":"int32"},"jobs":{"type":"array","items":{"$ref":"#/components/schemas/v1RolloutJobInfo"}},"nonJobInfo":{"type":"array","items":{"$ref":"#/components/schemas/v1RolloutNonJobInfo"}},"metrics":{"type":"array","items":{"$ref":"#/components/schemas/v1Metric"}}}},"v1RolloutJobInfo":{"type":"object","properties":{"metadata":{"$ref":"#/components/schemas/v1ObjectMeta"},"status":{"type":"string"},"icon":{"type":"string"},"metricName":{"type":"string"},"startedAt":{"$ref":"#/components/schemas/v1Time"}}},"v1RolloutNonJobInfo":{"type":"object","properties":{"value":{"type":"string"},"status":{"type":"string"},"metricName":{"type":"string"},"startedAt":{"$ref":"#/components/schemas/v1Time"}}},"v1Metric":{"type":"object","properties":{"name":{"type":"string","title":"Name is the name of the metric"},"interval":{"type":"string","title":"Interval defines an interval string (e.g. 30s, 5m, 1h) between each measurement.\nIf omitted, will perform a single measurement"},"initialDelay":{"type":"string","title":"InitialDelay how long the AnalysisRun should wait before starting this metric"},"count":{"$ref":"#/components/schemas/intstrIntOrString"},"successCondition":{"type":"string","title":"SuccessCondition is an expression which determines if a measurement is considered successful\nExpression is a goevaluate expression. The keyword `result` is a variable reference to the\nvalue of measurement. Results can be both structured data or primitive.\nExamples:\n  result > 10\n  (result.requests_made * result.requests_succeeded / 100) >= 90"},"failureCondition":{"type":"string","title":"FailureCondition is an expression which determines if a measurement is considered failed\nIf both success and failure conditions are specified, and the measurement does not fall into\neither condition, the measurement is considered Inconclusive"},"failureLimit":{"$ref":"#/components/schemas/intstrIntOrString"},"inconclusiveLimit":{"$ref":"#/components/schemas/intstrIntOrString"},"consecutiveErrorLimit":{"$ref":"#/components/schemas/intstrIntOrString"},"provider":{"$ref":"#/components/schemas/v1MetricProvider"}},"title":"Metric defines a metric in which to perform analysis"},"intstrIntOrString":{"type":"object","properties":{"type":{"type":"string","format":"int64"},"intVal":{"type":"integer","format":"int32"},"strVal":{"type":"string"}},"description":"+protobuf=true\n+protobuf.options.(gogoproto.goproto_stringer)=false\n+k8s:openapi-gen=true\n+k8s:openapi-model-package=io.k8s.apimachinery.pkg.util.intstr","title":"IntOrString is a type that can hold an int32 or a string.  When used in\nJSON or YAML marshalling and unmarshalling, it produces or consumes the\ninner type.  This allows you to have, for example, a JSON field that can\naccept a name or number.\nTODO: Rename to Int32OrString"},"v1MetricProvider":{"type":"object","properties":{"prometheus":{"$ref":"#/components/schemas/v1PrometheusMetric"},"kayenta":{"$ref":"#/components/schemas/v1KayentaMetric"},"web":{"$ref":"#/components/schemas/v1WebMetric"},"datadog":{"$ref":"#/components/schemas/v1DatadogMetric"},"wavefront":{"$ref":"#/components/schemas/v1WavefrontMetric"},"newRelic":{"$ref":"#/components/schemas/v1NewRelicMetric"},"job":{"$ref":"#/components/schemas/v1JobMetric"},"cloudWatch":{"$ref":"#/components/schemas/v1CloudWatchMetric"},"graphite":{"$ref":"#/components/schemas/v1GraphiteMetric"},"influxdb":{"$ref":"#/components/schemas/v1InfluxdbMetric"},"skywalking":{"$ref":"#/components/schemas/v1SkyWalkingMetric"},"plugin":{"type":"object","additionalProperties":{"type":"string","format":"byte"},"title":"+kubebuilder:validation:Schemaless\n+kubebuilder:pruning:PreserveUnknownFields\n+kubebuilder:validation:Type=object\nPlugin specifies the hashicorp go-plugin metric to query"}},"title":"MetricProvider which external system to use to verify the analysis\nOnly one of the fields in this struct should be non-nil"},"v1PrometheusMetric":{"type":"object","properties":{"address":{"type":"string","title":"Address is the HTTP address and port of the prometheus server"},"query":{"type":"string","title":"Query is a raw prometheus query to perform"},"authentication":{"$ref":"#/components/schemas/v1PrometheusAuth"},"timeout":{"type":"string","format":"int64","title":"Timeout represents the duration within which a prometheus query should complete. It is expressed in seconds.\n+optional"},"insecure":{"type":"boolean","title":"Insecure skips host TLS verification"},"headers":{"type":"array","items":{"$ref":"#/components/schemas/v1WebMetricHeader"},"title":"Headers are HTTP headers to use in the request\n+optional\n+patchMergeKey=key\n+patchStrategy=merge"}},"title":"PrometheusMetric defines the prometheus query to perform canary analysis"},"v1PrometheusAuth":{"type":"object","properties":{"sigv4":{"$ref":"#/components/schemas/v1Sigv4Config"}},"title":"PrometheusMetric defines the prometheus query to perform canary analysis"},"v1Sigv4Config":{"type":"object","properties":{"address":{"type":"string","title":"Region is the AWS Region to sign the SigV4 Request"},"profile":{"type":"string","title":"Profile is the Credential Profile used to sign the SigV4 Request"},"roleArn":{"type":"string","title":"RoleARN is the IAM role used to sign the SIgV4 Request"}}},"v1WebMetricHeader":{"type":"object","properties":{"key":{"type":"string"},"value":{"type":"string"}}},"v1KayentaMetric":{"type":"object","properties":{"address":{"type":"string"},"application":{"type":"string"},"canaryConfigName":{"type":"string"},"metricsAccountName":{"type":"string"},"configurationAccountName":{"type":"string"},"storageAccountName":{"type":"string"},"threshold":{"$ref":"#/components/schemas/v1KayentaThreshold"},"scopes":{"type":"array","items":{"$ref":"#/components/schemas/v1KayentaScope"}}}},"v1KayentaThreshold":{"type":"object","properties":{"pass":{"type":"string","format":"int64"},"marginal":{"type":"string","format":"int64"}}},"v1KayentaScope":{"type":"object","properties":{"name":{"type":"string"},"controlScope":{"$ref":"#/components/schemas/v1ScopeDetail"},"experimentScope":{"$ref":"#/components/schemas/v1ScopeDetail"}}},"v1ScopeDetail":{"type":"object","properties":{"scope":{"type":"string"},"region":{"type":"string"},"step":{"type":"string","format":"int64"},"start":{"type":"string"},"end":{"type":"string"}}},"v1WebMetric":{"type":"object","properties":{"method":{"type":"string","title":"Method is the method of the web metric (empty defaults to GET)"},"url":{"type":"string","title":"URL is the address of the web metric"},"headers":{"type":"array","items":{"$ref":"#/components/schemas/v1WebMetricHeader"},"title":"+patchMergeKey=key\n+patchStrategy=merge\nHeaders are HTTP headers to use in the request"},"body":{"type":"string","title":"Body is the body of the web metric (must be POST/PUT)"},"timeoutSeconds":{"type":"string","format":"int64","title":"TimeoutSeconds is the timeout for the request in seconds (default: 10)"},"jsonPath":{"type":"string","title":"JSONPath is a JSON Path to use as the result variable (default: \"{$}\")"},"insecure":{"type":"boolean","title":"Insecure skips host TLS verification"},"jsonBody":{"type":"string","format":"byte","title":"+kubebuilder:validation:Schemaless\n+kubebuilder:pruning:PreserveUnknownFields\n+kubebuilder:validation:Type=object\nJSONBody is the body of the web metric in a json format (method must be POST/PUT)"}}},"v1DatadogMetric":{"type":"object","properties":{"interval":{"type":"string"},"query":{"type":"string"},"apiVersion":{"type":"string","description":"ApiVersion refers to the Datadog API version being used (default: v1). v1 will eventually be deprecated."}}},"v1WavefrontMetric":{"type":"object","properties":{"address":{"type":"string","title":"Address is the HTTP address and port of the wavefront server"},"query":{"type":"string","title":"Query is a raw wavefront query to perform"}},"title":"WavefrontMetric defines the wavefront query to perform canary analysis"},"v1NewRelicMetric":{"type":"object","properties":{"profile":{"type":"string","title":"Profile is the name of the secret holding NR account configuration"},"query":{"type":"string","title":"Query is a raw newrelic NRQL query to perform"}},"title":"NewRelicMetric defines the newrelic query to perform canary analysis"},"v1JobMetric":{"type":"object","properties":{"metadata":{"$ref":"#/components/schemas/v1ObjectMeta"},"spec":{"$ref":"#/components/schemas/v1JobSpec"}},"title":"JobMetric defines a job to run which acts as a metric"},"v1JobSpec":{"type":"object","properties":{"parallelism":{"type":"integer","format":"int32","title":"Specifies the maximum desired number of pods the job should\nrun at any given time. The actual number of pods running in steady state will\nbe less than this number when ((.spec.completions - .status.successful) < .spec.parallelism),\ni.e. when the work left to do is less than max parallelism.\nMore info: https://kubernetes.io/docs/concepts/workloads/controllers/jobs-run-to-completion/\n+optional"},"completions":{"type":"integer","format":"int32","title":"Specifies the desired number of successfully finished pods the\njob should be run with.  Setting to null means that the success of any\npod signals the success of all pods, and allows parallelism to have any positive\nvalue.  Setting to 1 means that parallelism is limited to 1 and the success of that\npod signals the success of the job.\nMore info: https://kubernetes.io/docs/concepts/workloads/controllers/jobs-run-to-completion/\n+optional"},"activeDeadlineSeconds":{"type":"string","format":"int64","title":"Specifies the duration in seconds relative to the startTime that the job\nmay be continuously active before the system tries to terminate it; value\nmust be positive integer. If a Job is suspended (at creation or through an\nupdate), this timer will effectively be stopped and reset when the Job is\nresumed again.\n+optional"},"podFailurePolicy":{"$ref":"#/components/schemas/v1PodFailurePolicy"},"successPolicy":{"$ref":"#/components/schemas/v1SuccessPolicy"},"backoffLimit":{"type":"integer","format":"int32","title":"Specifies the number of retries before marking this job failed.\nDefaults to 6, unless backoffLimitPerIndex (only Indexed Job) is specified.\nWhen backoffLimitPerIndex is specified, backoffLimit defaults to 2147483647.\n+optional"},"backoffLimitPerIndex":{"type":"integer","format":"int32","title":"Specifies the limit for the number of retries within an\nindex before marking this index as failed. When enabled the number of\nfailures per index is kept in the pod's\nbatch.kubernetes.io/job-index-failure-count annotation. It can only\nbe set when Job's completionMode=Indexed, and the Pod's restart\npolicy is Never. The field is immutable.\n+optional"},"maxFailedIndexes":{"type":"integer","format":"int32","title":"Specifies the maximal number of failed indexes before marking the Job as\nfailed, when backoffLimitPerIndex is set. Once the number of failed\nindexes exceeds this number the entire Job is marked as Failed and its\nexecution is terminated. When left as null the job continues execution of\nall of its indexes and is marked with the `Complete` Job condition.\nIt can only be specified when backoffLimitPerIndex is set.\nIt can be null or up to completions. It is required and must be\nless than or equal to 10^4 when is completions greater than 10^5.\n+optional"},"selector":{"$ref":"#/components/schemas/v1LabelSelector"},"manualSelector":{"type":"boolean","title":"manualSelector controls generation of pod labels and pod selectors.\nLeave `manualSelector` unset unless you are certain what you are doing.\nWhen false or unset, the system pick labels unique to this job\nand appends those labels to the pod template.  When true,\nthe user is responsible for picking unique labels and specifying\nthe selector.  Failure to pick a unique label may cause this\nand other jobs to not function correctly.  However, You may see\n`manualSelector=true` in jobs that were created with the old `extensions/v1beta1`\nAPI.\nMore info: https://kubernetes.io/docs/concepts/workloads/controllers/jobs-run-to-completion/#specifying-your-own-pod-selector\n+optional"},"template":{"$ref":"#/components/schemas/v1PodTemplateSpec"},"ttlSecondsAfterFinished":{"type":"integer","format":"int32","title":"ttlSecondsAfterFinished limits the lifetime of a Job that has finished\nexecution (either Complete or Failed). If this field is set,\nttlSecondsAfterFinished after the Job finishes, it is eligible to be\nautomatically deleted. When the Job is being deleted, its lifecycle\nguarantees (e.g. finalizers) will be honored. If this field is unset,\nthe Job won't be automatically deleted. If this field is set to zero,\nthe Job becomes eligible to be deleted immediately after it finishes.\n+optional"},"completionMode":{"type":"string","description":"completionMode specifies how Pod completions are tracked. It can be\n`NonIndexed` (default) or `Indexed`.\n\n`NonIndexed` means that the Job is considered complete when there have\nbeen .spec.completions successfully completed Pods. Each Pod completion is\nhomologous to each other.\n\n`Indexed` means that the Pods of a\nJob get an associated completion index from 0 to (.spec.completions - 1),\navailable in the annotation batch.kubernetes.io/job-completion-index.\nThe Job is considered complete when there is one successfully completed Pod\nfor each index.\nWhen value is `Indexed`, .spec.completions must be specified and\n`.spec.parallelism` must be less than or equal to 10^5.\nIn addition, The Pod name takes the form\n`$(job-name)-$(index)-$(random-string)`,\nthe Pod hostname takes the form `$(job-name)-$(index)`.\n\nMore completion modes can be added in the future.\nIf the Job controller observes a mode that it doesn't recognize, which\nis possible during upgrades due to version skew, the controller\nskips updates for the Job.\n+optional"},"suspend":{"type":"boolean","description":"suspend specifies whether the Job controller should create Pods or not. If\na Job is created with suspend set to true, no Pods are created by the Job\ncontroller. If a Job is suspended after creation (i.e. the flag goes from\nfalse to true), the Job controller will delete all active Pods associated\nwith this Job. Users must design their workload to gracefully handle this.\nSuspending a Job will reset the StartTime field of the Job, effectively\nresetting the ActiveDeadlineSeconds timer too. Defaults to false.\n\n+optional"},"podReplacementPolicy":{"type":"string","description":"podReplacementPolicy specifies when to create replacement Pods.\nPossible values are:\n- TerminatingOrFailed means that we recreate pods\n  when they are terminating (has a metadata.deletionTimestamp) or failed.\n- Failed means to wait until a previously created Pod is fully terminated (has phase\n  Failed or Succeeded) before creating a replacement Pod.\n\nWhen using podFailurePolicy, Failed is the the only allowed value.\nTerminatingOrFailed and Failed are allowed values when podFailurePolicy is not in use.\n+optional"},"managedBy":{"type":"string","title":"ManagedBy field indicates the controller that manages a Job. The k8s Job\ncontroller reconciles jobs which don't have this field at all or the field\nvalue is the reserved string `kubernetes.io/job-controller`, but skips\nreconciling Jobs with a custom value for this field.\nThe value must be a valid domain-prefixed path (e.g. acme.io/foo) -\nall characters before the first \"/\" must be a valid subdomain as defined\nby RFC 1123. All characters trailing the first \"/\" must be valid HTTP Path\ncharacters as defined by RFC 3986. The value cannot exceed 63 characters.\nThis field is immutable.\n+optional"}},"description":"JobSpec describes how the job execution will look like."},"v1PodFailurePolicy":{"type":"object","properties":{"rules":{"type":"array","items":{"$ref":"#/components/schemas/v1PodFailurePolicyRule"},"title":"A list of pod failure policy rules. The rules are evaluated in order.\nOnce a rule matches a Pod failure, the remaining of the rules are ignored.\nWhen no rule matches the Pod failure, the default handling applies - the\ncounter of pod failures is incremented and it is checked against\nthe backoffLimit. At most 20 elements are allowed.\n+listType=atomic"}},"description":"PodFailurePolicy describes how failed pods influence the backoffLimit."},"v1PodFailurePolicyRule":{"type":"object","properties":{"action":{"type":"string","description":"- FailJob: indicates that the pod's job is marked as Failed and all\n  running pods are terminated.\n- FailIndex: indicates that the pod's index is marked as Failed and will\n  not be restarted.\n- Ignore: indicates that the counter towards the .backoffLimit is not\n  incremented and a replacement pod is created.\n- Count: indicates that the pod is handled in the default way - the\n  counter towards the .backoffLimit is incremented.\nAdditional values are considered to be added in the future. Clients should\nreact to an unknown action by skipping the rule.","title":"Specifies the action taken on a pod failure when the requirements are satisfied.\nPossible values are:"},"onExitCodes":{"$ref":"#/components/schemas/v1PodFailurePolicyOnExitCodesRequirement"},"onPodConditions":{"type":"array","items":{"$ref":"#/components/schemas/v1PodFailurePolicyOnPodConditionsPattern"},"title":"Represents the requirement on the pod conditions. The requirement is represented\nas a list of pod condition patterns. The requirement is satisfied if at\nleast one pattern matches an actual pod condition. At most 20 elements are allowed.\n+listType=atomic\n+optional"}},"description":"PodFailurePolicyRule describes how a pod failure is handled when the requirements are met.\nOne of onExitCodes and onPodConditions, but not both, can be used in each rule."},"v1PodFailurePolicyOnExitCodesRequirement":{"type":"object","properties":{"containerName":{"type":"string","title":"Restricts the check for exit codes to the container with the\nspecified name. When null, the rule applies to all containers.\nWhen specified, it should match one the container or initContainer\nnames in the pod template.\n+optional"},"operator":{"type":"string","description":"- In: the requirement is satisfied if at least one container exit code\n  (might be multiple if there are multiple containers not restricted\n  by the 'containerName' field) is in the set of specified values.\n- NotIn: the requirement is satisfied if at least one container exit code\n  (might be multiple if there are multiple containers not restricted\n  by the 'containerName' field) is not in the set of specified values.\nAdditional values are considered to be added in the future. Clients should\nreact to an unknown operator by assuming the requirement is not satisfied.","title":"Represents the relationship between the container exit code(s) and the\nspecified values. Containers completed with success (exit code 0) are\nexcluded from the requirement check. Possible values are:"},"values":{"type":"array","items":{"type":"integer","format":"int32"},"title":"Specifies the set of values. Each returned container exit code (might be\nmultiple in case of multiple containers) is checked against this set of\nvalues with respect to the operator. The list of values must be ordered\nand must not contain duplicates. Value '0' cannot be used for the In operator.\nAt least one element is required. At most 255 elements are allowed.\n+listType=set"}},"description":"PodFailurePolicyOnExitCodesRequirement describes the requirement for handling\na failed pod based on its container exit codes. In particular, it lookups the\n.state.terminated.exitCode for each app container and init container status,\nrepresented by the .status.containerStatuses and .status.initContainerStatuses\nfields in the Pod status, respectively. Containers completed with success\n(exit code 0) are excluded from the requirement check."},"v1PodFailurePolicyOnPodConditionsPattern":{"type":"object","properties":{"type":{"type":"string","description":"Specifies the required Pod condition type. To match a pod condition\nit is required that specified type equals the pod condition type."},"status":{"type":"string","title":"Specifies the required Pod condition status. To match a pod condition\nit is required that the specified status equals the pod condition status.\nDefaults to True.\n+optional"}},"description":"PodFailurePolicyOnPodConditionsPattern describes a pattern for matching\nan actual pod condition type."},"v1SuccessPolicy":{"type":"object","properties":{"rules":{"type":"array","items":{"$ref":"#/components/schemas/v1SuccessPolicyRule"},"title":"rules represents the list of alternative rules for the declaring the Jobs\nas successful before `.status.succeeded >= .spec.completions`. Once any of the rules are met,\nthe \"SuccessCriteriaMet\" condition is added, and the lingering pods are removed.\nThe terminal state for such a Job has the \"Complete\" condition.\nAdditionally, these rules are evaluated in order; Once the Job meets one of the rules,\nother rules are ignored. At most 20 elements are allowed.\n+listType=atomic"}},"description":"SuccessPolicy describes when a Job can be declared as succeeded based on the success of some indexes."},"v1SuccessPolicyRule":{"type":"object","properties":{"succeededIndexes":{"type":"string","description":"succeededIndexes specifies the set of indexes\nwhich need to be contained in the actual set of the succeeded indexes for the Job.\nThe list of indexes must be within 0 to \".spec.completions-1\" and\nmust not contain duplicates. At least one element is required.\nThe indexes are represented as intervals separated by commas.\nThe intervals can be a decimal integer or a pair of decimal integers separated by a hyphen.\nThe number are listed in represented by the first and last element of the series,\nseparated by a hyphen.\nFor example, if the completed indexes are 1, 3, 4, 5 and 7, they are\nrepresented as \"1,3-5,7\".\nWhen this field is null, this field doesn't default to any value\nand is never evaluated at any time.\n\n+optional"},"succeededCount":{"type":"integer","format":"int32","description":"succeededCount specifies the minimal required size of the actual set of the succeeded indexes\nfor the Job. When succeededCount is used along with succeededIndexes, the check is\nconstrained only to the set of indexes specified by succeededIndexes.\nFor example, given that succeededIndexes is \"1-4\", succeededCount is \"3\",\nand completed indexes are \"1\", \"3\", and \"5\", the Job isn't declared as succeeded\nbecause only \"1\" and \"3\" indexes are considered in that rules.\nWhen this field is null, this doesn't default to any value and\nis never evaluated at any time.\nWhen specified it needs to be a positive integer.\n\n+optional"}},"description":"SuccessPolicyRule describes rule for declaring a Job as succeeded.\nEach rule must have at least one of the \"succeededIndexes\" or \"succeededCount\" specified."},"v1LabelSelector":{"type":"object","properties":{"matchLabels":{"type":"object","additionalProperties":{"type":"string"},"title":"matchLabels is a map of {key,value} pairs. A single {key,value} in the matchLabels\nmap is equivalent to an element of matchExpressions, whose key field is \"key\", the\noperator is \"In\", and the values array contains only \"value\". The requirements are ANDed.\n+optional"},"matchExpressions":{"type":"array","items":{"$ref":"#/components/schemas/v1LabelSelectorRequirement"},"title":"matchExpressions is a list of label selector requirements. The requirements are ANDed.\n+optional\n+listType=atomic"}},"title":"A label selector is a label query over a set of resources. The result of matchLabels and\nmatchExpressions are ANDed. An empty label selector matches all objects. A null\nlabel selector matches no objects.\n+structType=atomic"},"v1LabelSelectorRequirement":{"type":"object","properties":{"key":{"type":"string","description":"key is the label key that the selector applies to."},"operator":{"type":"string","description":"operator represents a key's relationship to a set of values.\nValid operators are In, NotIn, Exists and DoesNotExist."},"values":{"type":"array","items":{"type":"string"},"title":"values is an array of string values. If the operator is In or NotIn,\nthe values array must be non-empty. If the operator is Exists or DoesNotExist,\nthe values array must be empty. This array is replaced during a strategic\nmerge patch.\n+optional\n+listType=atomic"}},"description":"A label selector requirement is a selector that contains values, a key, and an operator that\nrelates the key and values."},"v1PodTemplateSpec":{"type":"object","properties":{"metadata":{"$ref":"#/components/schemas/v1ObjectMeta"},"spec":{"$ref":"#/components/schemas/v1PodSpec"}},"title":"PodTemplateSpec describes the data a pod should have when created from a template"},"v1PodSpec":{"type":"object","properties":{"volumes":{"type":"array","items":{"$ref":"#/components/schemas/v1Volume"},"title":"List of volumes that can be mounted by containers belonging to the pod.\nMore info: https://kubernetes.io/docs/concepts/storage/volumes\n+optional\n+patchMergeKey=name\n+patchStrategy=merge,retainKeys\n+listType=map\n+listMapKey=name"},"initContainers":{"type":"array","items":{"$ref":"#/components/schemas/v1Container"},"title":"List of initialization containers belonging to the pod.\nInit containers are executed in order prior to containers being started. If any\ninit container fails, the pod is considered to have failed and is handled according\nto its restartPolicy. The name for an init container or normal container must be\nunique among all containers.\nInit containers may not have Lifecycle actions, Readiness probes, Liveness probes, or Startup probes.\nThe resourceRequirements of an init container are taken into account during scheduling\nby finding the highest request/limit for each resource type, and then using the max of\nthat value or the sum of the normal containers. Limits are applied to init containers\nin a similar fashion.\nInit containers cannot currently be added or removed.\nCannot be updated.\nMore info: https://kubernetes.io/docs/concepts/workloads/pods/init-containers/\n+patchMergeKey=name\n+patchStrategy=merge\n+listType=map\n+listMapKey=name"},"containers":{"type":"array","items":{"$ref":"#/components/schemas/v1Container"},"title":"List of containers belonging to the pod.\nContainers cannot currently be added or removed.\nThere must be at least one container in a Pod.\nCannot be updated.\n+patchMergeKey=name\n+patchStrategy=merge\n+listType=map\n+listMapKey=name"},"ephemeralContainers":{"type":"array","items":{"$ref":"#/components/schemas/v1EphemeralContainer"},"title":"List of ephemeral containers run in this pod. Ephemeral containers may be run in an existing\npod to perform user-initiated actions such as debugging. This list cannot be specified when\ncreating a pod, and it cannot be modified by updating the pod spec. In order to add an\nephemeral container to an existing pod, use the pod's ephemeralcontainers subresource.\n+optional\n+patchMergeKey=name\n+patchStrategy=merge\n+listType=map\n+listMapKey=name"},"restartPolicy":{"type":"string","title":"Restart policy for all containers within the pod.\nOne of Always, OnFailure, Never. In some contexts, only a subset of those values may be permitted.\nDefault to Always.\nMore info: https://kubernetes.io/docs/concepts/workloads/pods/pod-lifecycle/#restart-policy\n+optional"},"terminationGracePeriodSeconds":{"type":"string","format":"int64","title":"Optional duration in seconds the pod needs to terminate gracefully. May be decreased in delete request.\nValue must be non-negative integer. The value zero indicates stop immediately via\nthe kill signal (no opportunity to shut down).\nIf this value is nil, the default grace period will be used instead.\nThe grace period is the duration in seconds after the processes running in the pod are sent\na termination signal and the time when the processes are forcibly halted with a kill signal.\nSet this value longer than the expected cleanup time for your process.\nDefaults to 30 seconds.\n+optional"},"activeDeadlineSeconds":{"type":"string","format":"int64","title":"Optional duration in seconds the pod may be active on the node relative to\nStartTime before the system will actively try to mark it failed and kill associated containers.\nValue must be a positive integer.\n+optional"},"dnsPolicy":{"type":"string","title":"Set DNS policy for the pod.\nDefaults to \"ClusterFirst\".\nValid values are 'ClusterFirstWithHostNet', 'ClusterFirst', 'Default' or 'None'.\nDNS parameters given in DNSConfig will be merged with the policy selected with DNSPolicy.\nTo have DNS options set along with hostNetwork, you have to specify DNS policy\nexplicitly to 'ClusterFirstWithHostNet'.\n+optional"},"nodeSelector":{"type":"object","additionalProperties":{"type":"string"},"title":"NodeSelector is a selector which must be true for the pod to fit on a node.\nSelector which must match a node's labels for the pod to be scheduled on that node.\nMore info: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/\n+optional\n+mapType=atomic"},"serviceAccountName":{"type":"string","title":"ServiceAccountName is the name of the ServiceAccount to use to run this pod.\nMore info: https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/\n+optional"},"serviceAccount":{"type":"string","title":"DeprecatedServiceAccount is a deprecated alias for ServiceAccountName.\nDeprecated: Use serviceAccountName instead.\n+k8s:conversion-gen=false\n+optional"},"automountServiceAccountToken":{"type":"boolean","title":"AutomountServiceAccountToken indicates whether a service account token should be automatically mounted.\n+optional"},"nodeName":{"type":"string","title":"NodeName indicates in which node this pod is scheduled.\nIf empty, this pod is a candidate for scheduling by the scheduler defined in schedulerName.\nOnce this field is set, the kubelet for this node becomes responsible for the lifecycle of this pod.\nThis field should not be used to express a desire for the pod to be scheduled on a specific node.\nhttps://kubernetes.io/docs/concepts/scheduling-eviction/assign-pod-node/#nodename\n+optional"},"hostNetwork":{"type":"boolean","title":"Host networking requested for this pod. Use the host's network namespace.\nWhen using HostNetwork you should specify ports so the scheduler is aware.\nWhen `hostNetwork` is true, specified `hostPort` fields in port definitions must match `containerPort`,\nand unspecified `hostPort` fields in port definitions are defaulted to match `containerPort`.\nDefault to false.\n+k8s:conversion-gen=false\n+optional"},"hostPID":{"type":"boolean","title":"Use the host's pid namespace.\nOptional: Default to false.\n+k8s:conversion-gen=false\n+optional"},"hostIPC":{"type":"boolean","title":"Use the host's ipc namespace.\nOptional: Default to false.\n+k8s:conversion-gen=false\n+optional"},"shareProcessNamespace":{"type":"boolean","title":"Share a single process namespace between all of the containers in a pod.\nWhen this is set containers will be able to view and signal processes from other containers\nin the same pod, and the first process in each container will not be assigned PID 1.\nHostPID and ShareProcessNamespace cannot both be set.\nOptional: Default to false.\n+k8s:conversion-gen=false\n+optional"},"securityContext":{"$ref":"#/components/schemas/v1PodSecurityContext"},"imagePullSecrets":{"type":"array","items":{"$ref":"#/components/schemas/v1LocalObjectReference"},"title":"ImagePullSecrets is an optional list of references to secrets in the same namespace to use for pulling any of the images used by this PodSpec.\nIf specified, these secrets will be passed to individual puller implementations for them to use.\nMore info: https://kubernetes.io/docs/concepts/containers/images#specifying-imagepullsecrets-on-a-pod\n+optional\n+patchMergeKey=name\n+patchStrategy=merge\n+listType=map\n+listMapKey=name"},"hostname":{"type":"string","title":"Specifies the hostname of the Pod\nIf not specified, the pod's hostname will be set to a system-defined value.\n+optional"},"subdomain":{"type":"string","title":"If specified, the fully qualified Pod hostname will be \"<hostname>.<subdomain>.<pod namespace>.svc.<cluster domain>\".\nIf not specified, the pod will not have a domainname at all.\n+optional"},"affinity":{"$ref":"#/components/schemas/v1Affinity"},"schedulerName":{"type":"string","title":"If specified, the pod will be dispatched by specified scheduler.\nIf not specified, the pod will be dispatched by default scheduler.\n+optional"},"tolerations":{"type":"array","items":{"$ref":"#/components/schemas/v1Toleration"},"title":"If specified, the pod's tolerations.\n+optional\n+listType=atomic"},"hostAliases":{"type":"array","items":{"$ref":"#/components/schemas/v1HostAlias"},"title":"HostAliases is an optional list of hosts and IPs that will be injected into the pod's hosts\nfile if specified.\n+optional\n+patchMergeKey=ip\n+patchStrategy=merge\n+listType=map\n+listMapKey=ip"},"priorityClassName":{"type":"string","title":"If specified, indicates the pod's priority. \"system-node-critical\" and\n\"system-cluster-critical\" are two special keywords which indicate the\nhighest priorities with the former being the highest priority. Any other\nname must be defined by creating a PriorityClass object with that name.\nIf not specified, the pod priority will be default or zero if there is no\ndefault.\n+optional"},"priority":{"type":"integer","format":"int32","title":"The priority value. Various system components use this field to find the\npriority of the pod. When Priority Admission Controller is enabled, it\nprevents users from setting this field. The admission controller populates\nthis field from PriorityClassName.\nThe higher the value, the higher the priority.\n+optional"},"dnsConfig":{"$ref":"#/components/schemas/v1PodDNSConfig"},"readinessGates":{"type":"array","items":{"$ref":"#/components/schemas/v1PodReadinessGate"},"title":"If specified, all readiness gates will be evaluated for pod readiness.\nA pod is ready when all its containers are ready AND\nall conditions specified in the readiness gates have status equal to \"True\"\nMore info: https://git.k8s.io/enhancements/keps/sig-network/580-pod-readiness-gates\n+optional\n+listType=atomic"},"runtimeClassName":{"type":"string","title":"RuntimeClassName refers to a RuntimeClass object in the node.k8s.io group, which should be used\nto run this pod.  If no RuntimeClass resource matches the named class, the pod will not be run.\nIf unset or empty, the \"legacy\" RuntimeClass will be used, which is an implicit class with an\nempty definition that uses the default runtime handler.\nMore info: https://git.k8s.io/enhancements/keps/sig-node/585-runtime-class\n+optional"},"enableServiceLinks":{"type":"boolean","title":"EnableServiceLinks indicates whether information about services should be injected into pod's\nenvironment variables, matching the syntax of Docker links.\nOptional: Defaults to true.\n+optional"},"preemptionPolicy":{"type":"string","title":"PreemptionPolicy is the Policy for preempting pods with lower priority.\nOne of Never, PreemptLowerPriority.\nDefaults to PreemptLowerPriority if unset.\n+optional"},"overhead":{"type":"object","additionalProperties":{"$ref":"#/components/schemas/resourceQuantity"},"title":"Overhead represents the resource overhead associated with running a pod for a given RuntimeClass.\nThis field will be autopopulated at admission time by the RuntimeClass admission controller. If\nthe RuntimeClass admission controller is enabled, overhead must not be set in Pod create requests.\nThe RuntimeClass admission controller will reject Pod create requests which have the overhead already\nset. If RuntimeClass is configured and selected in the PodSpec, Overhead will be set to the value\ndefined in the corresponding RuntimeClass, otherwise it will remain unset and treated as zero.\nMore info: https://git.k8s.io/enhancements/keps/sig-node/688-pod-overhead/README.md\n+optional"},"topologySpreadConstraints":{"type":"array","items":{"$ref":"#/components/schemas/v1TopologySpreadConstraint"},"title":"TopologySpreadConstraints describes how a group of pods ought to spread across topology\ndomains. Scheduler will schedule pods in a way which abides by the constraints.\nAll topologySpreadConstraints are ANDed.\n+optional\n+patchMergeKey=topologyKey\n+patchStrategy=merge\n+listType=map\n+listMapKey=topologyKey\n+listMapKey=whenUnsatisfiable"},"setHostnameAsFQDN":{"type":"boolean","title":"If true the pod's hostname will be configured as the pod's FQDN, rather than the leaf name (the default).\nIn Linux containers, this means setting the FQDN in the hostname field of the kernel (the nodename field of struct utsname).\nIn Windows containers, this means setting the registry value of hostname for the registry key HKEY_LOCAL_MACHINE\\\\SYSTEM\\\\CurrentControlSet\\\\Services\\\\Tcpip\\\\Parameters to FQDN.\nIf a pod does not have FQDN, this has no effect.\nDefault to false.\n+optional"},"os":{"$ref":"#/components/schemas/v1PodOS"},"hostUsers":{"type":"boolean","title":"Use the host's user namespace.\nOptional: Default to true.\nIf set to true or not present, the pod will be run in the host user namespace, useful\nfor when the pod needs a feature only available to the host user namespace, such as\nloading a kernel module with CAP_SYS_MODULE.\nWhen set to false, a new userns is created for the pod. Setting false is useful for\nmitigating container breakout vulnerabilities even allowing users to run their\ncontainers as root without actually having root privileges on the host.\n+k8s:conversion-gen=false\n+optional"},"schedulingGates":{"type":"array","items":{"$ref":"#/components/schemas/v1PodSchedulingGate"},"description":"SchedulingGates is an opaque list of values that if specified will block scheduling the pod.\nIf schedulingGates is not empty, the pod will stay in the SchedulingGated state and the\nscheduler will not attempt to schedule the pod.\n\nSchedulingGates can only be set at pod creation time, and be removed only afterwards.\n\n+patchMergeKey=name\n+patchStrategy=merge\n+listType=map\n+listMapKey=name\n+optional"},"resourceClaims":{"type":"array","items":{"$ref":"#/components/schemas/v1PodResourceClaim"},"description":"ResourceClaims defines which ResourceClaims must be allocated\nand reserved before the Pod is allowed to start. The resources\nwill be made available to those containers which consume them\nby name.\n\nThis is a stable field but requires that the\nDynamicResourceAllocation feature gate is enabled.\n\nThis field is immutable.\n\n+patchMergeKey=name\n+patchStrategy=merge,retainKeys\n+listType=map\n+listMapKey=name\n+featureGate=DynamicResourceAllocation\n+optional"},"resources":{"$ref":"#/components/schemas/v1ResourceRequirements"},"hostnameOverride":{"type":"string","description":"HostnameOverride specifies an explicit override for the pod's hostname as perceived by the pod.\nThis field only specifies the pod's hostname and does not affect its DNS records.\nWhen this field is set to a non-empty string:\n- It takes precedence over the values set in `hostname` and `subdomain`.\n- The Pod's hostname will be set to this value.\n- `setHostnameAsFQDN` must be nil or set to false.\n- `hostNetwork` must be set to false.\n\nThis field must be a valid DNS subdomain as defined in RFC 1123 and contain at most 64 characters.\nRequires the HostnameOverride feature gate to be enabled.\n\n+featureGate=HostnameOverride\n+optional"},"schedulingGroup":{"$ref":"#/components/schemas/v1PodSchedulingGroup"}},"description":"PodSpec is a description of a pod."},"v1Volume":{"type":"object","properties":{"name":{"type":"string","title":"name of the volume.\nMust be a DNS_LABEL and unique within the pod.\nMore info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names"},"volumeSource":{"$ref":"#/components/schemas/v1VolumeSource"}},"description":"Volume represents a named volume in a pod that may be accessed by any container in the pod."},"v1VolumeSource":{"type":"object","properties":{"hostPath":{"$ref":"#/components/schemas/v1HostPathVolumeSource"},"emptyDir":{"$ref":"#/components/schemas/v1EmptyDirVolumeSource"},"gcePersistentDisk":{"$ref":"#/components/schemas/v1GCEPersistentDiskVolumeSource"},"awsElasticBlockStore":{"$ref":"#/components/schemas/v1AWSElasticBlockStoreVolumeSource"},"gitRepo":{"$ref":"#/components/schemas/v1GitRepoVolumeSource"},"secret":{"$ref":"#/components/schemas/v1SecretVolumeSource"},"nfs":{"$ref":"#/components/schemas/v1NFSVolumeSource"},"iscsi":{"$ref":"#/components/schemas/v1ISCSIVolumeSource"},"glusterfs":{"$ref":"#/components/schemas/v1GlusterfsVolumeSource"},"persistentVolumeClaim":{"$ref":"#/components/schemas/v1PersistentVolumeClaimVolumeSource"},"rbd":{"$ref":"#/components/schemas/v1RBDVolumeSource"},"flexVolume":{"$ref":"#/components/schemas/v1FlexVolumeSource"},"cinder":{"$ref":"#/components/schemas/v1CinderVolumeSource"},"cephfs":{"$ref":"#/components/schemas/v1CephFSVolumeSource"},"flocker":{"$ref":"#/components/schemas/v1FlockerVolumeSource"},"downwardAPI":{"$ref":"#/components/schemas/v1DownwardAPIVolumeSource"},"fc":{"$ref":"#/components/schemas/v1FCVolumeSource"},"azureFile":{"$ref":"#/components/schemas/v1AzureFileVolumeSource"},"configMap":{"$ref":"#/components/schemas/v1ConfigMapVolumeSource"},"vsphereVolume":{"$ref":"#/components/schemas/v1VsphereVirtualDiskVolumeSource"},"quobyte":{"$ref":"#/components/schemas/v1QuobyteVolumeSource"},"azureDisk":{"$ref":"#/components/schemas/v1AzureDiskVolumeSource"},"photonPersistentDisk":{"$ref":"#/components/schemas/v1PhotonPersistentDiskVolumeSource"},"projected":{"$ref":"#/components/schemas/v1ProjectedVolumeSource"},"portworxVolume":{"$ref":"#/components/schemas/v1PortworxVolumeSource"},"scaleIO":{"$ref":"#/components/schemas/v1ScaleIOVolumeSource"},"storageos":{"$ref":"#/components/schemas/v1StorageOSVolumeSource"},"csi":{"$ref":"#/components/schemas/v1CSIVolumeSource"},"ephemeral":{"$ref":"#/components/schemas/v1EphemeralVolumeSource"},"image":{"$ref":"#/components/schemas/v1ImageVolumeSource"}},"description":"Represents the source of a volume to mount.\nOnly one of its members may be specified."},"v1HostPathVolumeSource":{"type":"object","properties":{"path":{"type":"string","title":"path of the directory on the host.\nIf the path is a symlink, it will follow the link to the real path.\nMore info: https://kubernetes.io/docs/concepts/storage/volumes#hostpath"},"type":{"type":"string","title":"type for HostPath Volume\nDefaults to \"\"\nMore info: https://kubernetes.io/docs/concepts/storage/volumes#hostpath\n+optional"}},"description":"Represents a host path mapped into a pod.\nHost path volumes do not support ownership management or SELinux relabeling."},"v1EmptyDirVolumeSource":{"type":"object","properties":{"medium":{"type":"string","title":"medium represents what type of storage medium should back this directory.\nThe default is \"\" which means to use the node's default medium.\nMust be an empty string (default) or Memory.\nMore info: https://kubernetes.io/docs/concepts/storage/volumes#emptydir\n+optional"},"sizeLimit":{"$ref":"#/components/schemas/resourceQuantity"}},"description":"Represents an empty directory for a pod.\nEmpty directory volumes support ownership management and SELinux relabeling."},"resourceQuantity":{"type":"object","properties":{"string":{"type":"string"}},"description":"Quantity is a fixed-point representation of a number.\nIt provides convenient marshaling/unmarshaling in JSON and YAML,\nin addition to String() and AsInt64() accessors.\n\nThe serialization format is:\n\n```\n<quantity>        ::= <signedNumber><suffix>\n\n\t(Note that <suffix> may be empty, from the \"\" case in <decimalSI>.)\n\n<digit>           ::= 0 | 1 | ... | 9\n<digits>          ::= <digit> | <digit><digits>\n<number>          ::= <digits> | <digits>.<digits> | <digits>. | .<digits>\n<sign>            ::= \"+\" | \"-\"\n<signedNumber>    ::= <number> | <sign><number>\n<suffix>          ::= <binarySI> | <decimalExponent> | <decimalSI>\n<binarySI>        ::= Ki | Mi | Gi | Ti | Pi | Ei\n\n\t(International System of units; See: http://physics.nist.gov/cuu/Units/binary.html)\n\n<decimalSI>       ::= m | \"\" | k | M | G | T | P | E\n\n\t(Note that 1024 = 1Ki but 1000 = 1k; I didn't choose the capitalization.)\n\n<decimalExponent> ::= \"e\" <signedNumber> | \"E\" <signedNumber>\n```\n\nNo matter which of the three exponent forms is used, no quantity may represent\na number greater than 2^63-1 in magnitude, nor may it have more than 3 decimal\nplaces. Numbers larger or more precise will be capped or rounded up.\n(E.g.: 0.1m will rounded up to 1m.)\nThis may be extended in the future if we require larger or smaller quantities.\n\nWhen a Quantity is parsed from a string, it will remember the type of suffix\nit had, and will use the same type again when it is serialized.\n\nBefore serializing, Quantity will be put in \"canonical form\".\nThis means that Exponent/suffix will be adjusted up or down (with a\ncorresponding increase or decrease in Mantissa) such that:\n\n- No precision is lost\n- No fractional digits will be emitted\n- The exponent (or suffix) is as large as possible.\n\nThe sign will be omitted unless the number is negative.\n\nExamples:\n\n- 1.5 will be serialized as \"1500m\"\n- 1.5Gi will be serialized as \"1536Mi\"\n\nNote that the quantity will NEVER be internally represented by a\nfloating point number. That is the whole point of this exercise.\n\nNon-canonical values will still parse as long as they are well formed,\nbut will be re-emitted in their canonical form. (So always use canonical\nform, or don't diff.)\n\nThis format is intended to make it difficult to use these numbers without\nwriting some sort of special handling code in the hopes that that will\ncause implementors to also use a fixed point implementation.\n\n+protobuf=true\n+protobuf.embed=string\n+protobuf.options.marshal=false\n+protobuf.options.(gogoproto.goproto_stringer)=false\n+k8s:deepcopy-gen=true\n+k8s:openapi-gen=true\n+k8s:openapi-model-package=io.k8s.apimachinery.pkg.api.resource"},"v1GCEPersistentDiskVolumeSource":{"type":"object","properties":{"pdName":{"type":"string","title":"pdName is unique name of the PD resource in GCE. Used to identify the disk in GCE.\nMore info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk"},"fsType":{"type":"string","title":"fsType is filesystem type of the volume that you want to mount.\nTip: Ensure that the filesystem type is supported by the host operating system.\nExamples: \"ext4\", \"xfs\", \"ntfs\". Implicitly inferred to be \"ext4\" if unspecified.\nMore info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk\nTODO: how do we prevent errors in the filesystem from compromising the machine\n+optional"},"partition":{"type":"integer","format":"int32","title":"partition is the partition in the volume that you want to mount.\nIf omitted, the default is to mount by volume name.\nExamples: For volume /dev/sda1, you specify the partition as \"1\".\nSimilarly, the volume partition for /dev/sda is \"0\" (or you can leave the property empty).\nMore info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk\n+optional"},"readOnly":{"type":"boolean","title":"readOnly here will force the ReadOnly setting in VolumeMounts.\nDefaults to false.\nMore info: https://kubernetes.io/docs/concepts/storage/volumes#gcepersistentdisk\n+optional"}},"description":"Represents a Persistent Disk resource in Google Compute Engine.\n\nA GCE PD must exist before mounting to a container. The disk must\nalso be in the same GCE project and zone as the kubelet. A GCE PD\ncan only be mounted as read/write once or read-only many times. GCE\nPDs support ownership management and SELinux relabeling."},"v1AWSElasticBlockStoreVolumeSource":{"type":"object","properties":{"volumeID":{"type":"string","title":"volumeID is unique ID of the persistent disk resource in AWS (Amazon EBS volume).\nMore info: https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore"},"fsType":{"type":"string","title":"fsType is the filesystem type of the volume that you want to mount.\nTip: Ensure that the filesystem type is supported by the host operating system.\nExamples: \"ext4\", \"xfs\", \"ntfs\". Implicitly inferred to be \"ext4\" if unspecified.\nMore info: https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore\nTODO: how do we prevent errors in the filesystem from compromising the machine\n+optional"},"partition":{"type":"integer","format":"int32","title":"partition is the partition in the volume that you want to mount.\nIf omitted, the default is to mount by volume name.\nExamples: For volume /dev/sda1, you specify the partition as \"1\".\nSimilarly, the volume partition for /dev/sda is \"0\" (or you can leave the property empty).\n+optional"},"readOnly":{"type":"boolean","title":"readOnly value true will force the readOnly setting in VolumeMounts.\nMore info: https://kubernetes.io/docs/concepts/storage/volumes#awselasticblockstore\n+optional"}},"description":"Represents a Persistent Disk resource in AWS.\n\nAn AWS EBS disk must exist before mounting to a container. The disk\nmust also be in the same AWS zone as the kubelet. An AWS EBS disk\ncan only be mounted as read/write once. AWS EBS volumes support\nownership management and SELinux relabeling."},"v1GitRepoVolumeSource":{"type":"object","properties":{"repository":{"type":"string","title":"repository is the URL"},"revision":{"type":"string","title":"revision is the commit hash for the specified revision.\n+optional"},"directory":{"type":"string","title":"directory is the target directory name.\nMust not contain or start with '..'.  If '.' is supplied, the volume directory will be the\ngit repository.  Otherwise, if specified, the volume will contain the git repository in\nthe subdirectory with the given name.\n+optional"}},"description":"Represents a volume that is populated with the contents of a git repository.\nGit repo volumes do not support ownership management.\nGit repo volumes support SELinux relabeling.\n\nDEPRECATED: GitRepo is deprecated. To provision a container with a git repo, mount an\nEmptyDir into an InitContainer that clones the repo using git, then mount the EmptyDir\ninto the Pod's container."},"v1SecretVolumeSource":{"type":"object","properties":{"secretName":{"type":"string","title":"secretName is the name of the secret in the pod's namespace to use.\nMore info: https://kubernetes.io/docs/concepts/storage/volumes#secret\n+optional"},"items":{"type":"array","items":{"$ref":"#/components/schemas/v1KeyToPath"},"title":"items If unspecified, each key-value pair in the Data field of the referenced\nSecret will be projected into the volume as a file whose name is the\nkey and content is the value. If specified, the listed keys will be\nprojected into the specified paths, and unlisted keys will not be\npresent. If a key is specified which is not present in the Secret,\nthe volume setup will error unless it is marked optional. Paths must be\nrelative and may not contain the '..' path or start with '..'.\n+optional\n+listType=atomic"},"defaultMode":{"type":"integer","format":"int32","title":"defaultMode is Optional: mode bits used to set permissions on created files by default.\nMust be an octal value between 0000 and 0777 or a decimal value between 0 and 511.\nYAML accepts both octal and decimal values, JSON requires decimal values\nfor mode bits. Defaults to 0644.\nDirectories within the path are not affected by this setting.\nThis might be in conflict with other options that affect the file\nmode, like fsGroup, and the result can be other mode bits set.\n+optional"},"optional":{"type":"boolean","title":"optional field specify whether the Secret or its keys must be defined\n+optional"}},"description":"Adapts a Secret into a volume.\n\nThe contents of the target Secret's Data field will be presented in a volume\nas files using the keys in the Data field as the file names.\nSecret volumes support ownership management and SELinux relabeling."},"v1KeyToPath":{"type":"object","properties":{"key":{"type":"string","description":"key is the key to project."},"path":{"type":"string","description":"path is the relative path of the file to map the key to.\nMay not be an absolute path.\nMay not contain the path element '..'.\nMay not start with the string '..'."},"mode":{"type":"integer","format":"int32","title":"mode is Optional: mode bits used to set permissions on this file.\nMust be an octal value between 0000 and 0777 or a decimal value between 0 and 511.\nYAML accepts both octal and decimal values, JSON requires decimal values for mode bits.\nIf not specified, the volume defaultMode will be used.\nThis might be in conflict with other options that affect the file\nmode, like fsGroup, and the result can be other mode bits set.\n+optional"}},"description":"Maps a string key to a path within a volume."},"v1NFSVolumeSource":{"type":"object","properties":{"server":{"type":"string","title":"server is the hostname or IP address of the NFS server.\nMore info: https://kubernetes.io/docs/concepts/storage/volumes#nfs"},"path":{"type":"string","title":"path that is exported by the NFS server.\nMore info: https://kubernetes.io/docs/concepts/storage/volumes#nfs"},"readOnly":{"type":"boolean","title":"readOnly here will force the NFS export to be mounted with read-only permissions.\nDefaults to false.\nMore info: https://kubernetes.io/docs/concepts/storage/volumes#nfs\n+optional"}},"description":"Represents an NFS mount that lasts the lifetime of a pod.\nNFS volumes do not support ownership management or SELinux relabeling."},"v1ISCSIVolumeSource":{"type":"object","properties":{"targetPortal":{"type":"string","description":"targetPortal is iSCSI Target Portal. The Portal is either an IP or ip_addr:port if the port\nis other than default (typically TCP ports 860 and 3260)."},"iqn":{"type":"string","description":"iqn is the target iSCSI Qualified Name."},"lun":{"type":"integer","format":"int32","description":"lun represents iSCSI Target Lun number."},"iscsiInterface":{"type":"string","title":"iscsiInterface is the interface Name that uses an iSCSI transport.\nDefaults to 'default' (tcp).\n+optional\n+default=\"default\""},"fsType":{"type":"string","title":"fsType is the filesystem type of the volume that you want to mount.\nTip: Ensure that the filesystem type is supported by the host operating system.\nExamples: \"ext4\", \"xfs\", \"ntfs\". Implicitly inferred to be \"ext4\" if unspecified.\nMore info: https://kubernetes.io/docs/concepts/storage/volumes#iscsi\nTODO: how do we prevent errors in the filesystem from compromising the machine\n+optional"},"readOnly":{"type":"boolean","title":"readOnly here will force the ReadOnly setting in VolumeMounts.\nDefaults to false.\n+optional"},"portals":{"type":"array","items":{"type":"string"},"title":"portals is the iSCSI Target Portal List. The portal is either an IP or ip_addr:port if the port\nis other than default (typically TCP ports 860 and 3260).\n+optional\n+listType=atomic"},"chapAuthDiscovery":{"type":"boolean","title":"chapAuthDiscovery defines whether support iSCSI Discovery CHAP authentication\n+optional"},"chapAuthSession":{"type":"boolean","title":"chapAuthSession defines whether support iSCSI Session CHAP authentication\n+optional"},"secretRef":{"$ref":"#/components/schemas/v1LocalObjectReference"},"initiatorName":{"type":"string","title":"initiatorName is the custom iSCSI Initiator Name.\nIf initiatorName is specified with iscsiInterface simultaneously, new iSCSI interface\n<target portal>:<volume name> will be created for the connection.\n+optional"}},"description":"Represents an ISCSI disk.\nISCSI volumes can only be mounted as read/write once.\nISCSI volumes support ownership management and SELinux relabeling."},"v1LocalObjectReference":{"type":"object","properties":{"name":{"type":"string","description":"Name of the referent.\nThis field is effectively required, but due to backwards compatibility is\nallowed to be empty. Instances of this type with an empty value here are\nalmost certainly wrong.\nMore info: https://kubernetes.io/docs/concepts/overview/working-with-objects/names/#names\n+optional\n+default=\"\"\n+kubebuilder:default=\"\"\nTODO: Drop `kubebuilder:default` when controller-gen doesn't need it https://github.com/kubernetes-sigs/kubebuilder/issues/3896."}},"description":"LocalObjectReference contains enough information to let you locate the\nreferenced object inside the same namespace.\n---\nNew uses of this type are discouraged because of difficulty describing its usage when embedded in APIs.\n 1. Invalid usage help.  It is impossible to add specific help for individual usage.  In most embedded usages, there are particular\n    restrictions like, \"must refer only to types A and B\" or \"UID not honored\" or \"name must be restricted\".\n    Those cannot be well described when embedded.\n 2. Inconsistent validation.  Because the usages are different, the validation rules are different by usage, which makes it hard for users to predict what will happen.\n 3. We cannot easily change it.  Because this type is embedded in many locations, updates to this type\n    will affect numerous schemas.  Don't make new APIs embed an underspecified API type they do not control.\n\nInstead of using this type, create a locally provided and used type that is well-focused on your reference.\nFor example, ServiceReferences for admission registration: https://github.com/kubernetes/api/blob/release-1.17/admissionregistration/v1/types.go#L533 .\n+structType=atomic"},"v1GlusterfsVolumeSource":{"type":"object","properties":{"endpoints":{"type":"string","description":"endpoints is the endpoint name that details Glusterfs topology."},"path":{"type":"string","title":"path is the Glusterfs volume path.\nMore info: https://examples.k8s.io/volumes/glusterfs/README.md#create-a-pod"},"readOnly":{"type":"boolean","title":"readOnly here will force the Glusterfs volume to be mounted with read-only permissions.\nDefaults to false.\nMore info: https://examples.k8s.io/volumes/glusterfs/README.md#create-a-pod\n+optional"}},"description":"Represents a Glusterfs mount that lasts the lifetime of a pod.\nGlusterfs volumes do not support ownership management or SELinux relabeling."},"v1PersistentVolumeClaimVolumeSource":{"type":"object","properties":{"claimName":{"type":"string","title":"claimName is the name of a PersistentVolumeClaim in the same namespace as the pod using this volume.\nMore info: https://kubernetes.io/docs/concepts/storage/persistent-volumes#persistentvolumeclaims"},"readOnly":{"type":"boolean","title":"readOnly Will force the ReadOnly setting in VolumeMounts.\nDefault false.\n+optional"}},"description":"PersistentVolumeClaimVolumeSource references the user's PVC in the same namespace.\nThis volume finds the bound PV and mounts that volume for the pod. A\nPersistentVolumeClaimVolumeSource is, essentially, a wrapper around another\ntype of volume that is owned by someone else (the system)."},"v1RBDVolumeSource":{"type":"object","properties":{"monitors":{"type":"array","items":{"type":"string"},"title":"monitors is a collection of Ceph monitors.\nMore info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it\n+listType=atomic"},"image":{"type":"string","title":"image is the rados image name.\nMore info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it"},"fsType":{"type":"string","title":"fsType is the filesystem type of the volume that you want to mount.\nTip: Ensure that the filesystem type is supported by the host operating system.\nExamples: \"ext4\", \"xfs\", \"ntfs\". Implicitly inferred to be \"ext4\" if unspecified.\nMore info: https://kubernetes.io/docs/concepts/storage/volumes#rbd\nTODO: how do we prevent errors in the filesystem from compromising the machine\n+optional"},"pool":{"type":"string","title":"pool is the rados pool name.\nDefault is rbd.\nMore info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it\n+optional\n+default=\"rbd\""},"user":{"type":"string","title":"user is the rados user name.\nDefault is admin.\nMore info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it\n+optional\n+default=\"admin\""},"keyring":{"type":"string","title":"keyring is the path to key ring for RBDUser.\nDefault is /etc/ceph/keyring.\nMore info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it\n+optional\n+default=\"/etc/ceph/keyring\""},"secretRef":{"$ref":"#/components/schemas/v1LocalObjectReference"},"readOnly":{"type":"boolean","title":"readOnly here will force the ReadOnly setting in VolumeMounts.\nDefaults to false.\nMore info: https://examples.k8s.io/volumes/rbd/README.md#how-to-use-it\n+optional"}},"description":"Represents a Rados Block Device mount that lasts the lifetime of a pod.\nRBD volumes support ownership management and SELinux relabeling."},"v1FlexVolumeSource":{"type":"object","properties":{"driver":{"type":"string","description":"driver is the name of the driver to use for this volume."},"fsType":{"type":"string","title":"fsType is the filesystem type to mount.\nMust be a filesystem type supported by the host operating system.\nEx. \"ext4\", \"xfs\", \"ntfs\". The default filesystem depends on FlexVolume script.\n+optional"},"secretRef":{"$ref":"#/components/schemas/v1LocalObjectReference"},"readOnly":{"type":"boolean","title":"readOnly is Optional: defaults to false (read/write). ReadOnly here will force\nthe ReadOnly setting in VolumeMounts.\n+optional"},"options":{"type":"object","additionalProperties":{"type":"string"},"title":"options is Optional: this field holds extra command options if any.\n+optional"}},"description":"FlexVolume represents a generic volume resource that is\nprovisioned/attached using an exec based plugin."},"v1CinderVolumeSource":{"type":"object","properties":{"volumeID":{"type":"string","title":"volumeID used to identify the volume in cinder.\nMore info: https://examples.k8s.io/mysql-cinder-pd/README.md"},"fsType":{"type":"string","title":"fsType is the filesystem type to mount.\nMust be a filesystem type supported by the host operating system.\nExamples: \"ext4\", \"xfs\", \"ntfs\". Implicitly inferred to be \"ext4\" if unspecified.\nMore info: https://examples.k8s.io/mysql-cinder-pd/README.md\n+optional"},"readOnly":{"type":"boolean","title":"readOnly defaults to false (read/write). ReadOnly here will force\nthe ReadOnly setting in VolumeMounts.\nMore info: https://examples.k8s.io/mysql-cinder-pd/README.md\n+optional"},"secretRef":{"$ref":"#/components/schemas/v1LocalObjectReference"}},"description":"Represents a cinder volume resource in Openstack.\nA Cinder volume must exist before mounting to a container.\nThe volume must also be in the same region as the kubelet.\nCinder volumes support ownership management and SELinux relabeling."},"v1CephFSVolumeSource":{"type":"object","properties":{"monitors":{"type":"array","items":{"type":"string"},"title":"monitors is Required: Monitors is a collection of Ceph monitors\nMore info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it\n+listType=atomic"},"path":{"type":"string","title":"path is Optional: Used as the mounted root, rather than the full Ceph tree, default is /\n+optional"},"user":{"type":"string","title":"user is optional: User is the rados user name, default is admin\nMore info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it\n+optional"},"secretFile":{"type":"string","title":"secretFile is Optional: SecretFile is the path to key ring for User, default is /etc/ceph/user.secret\nMore info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it\n+optional"},"secretRef":{"$ref":"#/components/schemas/v1LocalObjectReference"},"readOnly":{"type":"boolean","title":"readOnly is Optional: Defaults to false (read/write). ReadOnly here will force\nthe ReadOnly setting in VolumeMounts.\nMore info: https://examples.k8s.io/volumes/cephfs/README.md#how-to-use-it\n+optional"}},"description":"Represents a Ceph Filesystem mount that lasts the lifetime of a pod\nCephfs volumes do not support ownership management or SELinux relabeling."},"v1FlockerVolumeSource":{"type":"object","properties":{"datasetName":{"type":"string","title":"datasetName is Name of the dataset stored as metadata -> name on the dataset for Flocker\nshould be considered as deprecated\n+optional"},"datasetUUID":{"type":"string","title":"datasetUUID is the UUID of the dataset. This is unique identifier of a Flocker dataset\n+optional"}},"description":"Represents a Flocker volume mounted by the Flocker agent.\nOne and only one of datasetName and datasetUUID should be set.\nFlocker volumes do not support ownership management or SELinux relabeling."},"v1DownwardAPIVolumeSource":{"type":"object","properties":{"items":{"type":"array","items":{"$ref":"#/components/schemas/v1DownwardAPIVolumeFile"},"title":"Items is a list of downward API volume file\n+optional\n+listType=atomic"},"defaultMode":{"type":"integer","format":"int32","title":"Optional: mode bits to use on created files by default. Must be a\nOptional: mode bits used to set permissions on created files by default.\nMust be an octal value between 0000 and 0777 or a decimal value between 0 and 511.\nYAML accepts both octal and decimal values, JSON requires decimal values for mode bits.\nDefaults to 0644.\nDirectories within the path are not affected by this setting.\nThis might be in conflict with other options that affect the file\nmode, like fsGroup, and the result can be other mode bits set.\n+optional"}},"description":"DownwardAPIVolumeSource represents a volume containing downward API info.\nDownward API volumes support ownership management and SELinux relabeling."},"v1DownwardAPIVolumeFile":{"type":"object","properties":{"path":{"type":"string","title":"Required: Path is  the relative path name of the file to be created. Must not be absolute or contain the '..' path. Must be utf-8 encoded. The first item of the relative path must not start with '..'"},"fieldRef":{"$ref":"#/components/schemas/v1ObjectFieldSelector"},"resourceFieldRef":{"$ref":"#/components/schemas/v1ResourceFieldSelector"},"mode":{"type":"integer","format":"int32","title":"Optional: mode bits used to set permissions on this file, must be an octal value\nbetween 0000 and 0777 or a decimal value between 0 and 511.\nYAML accepts both octal and decimal values, JSON requires decimal values for mode bits.\nIf not specified, the volume defaultMode will be used.\nThis might be in conflict with other options that affect the file\nmode, like fsGroup, and the result can be other mode bits set.\n+optional"}},"title":"DownwardAPIVolumeFile represents information to create the file containing the pod field"},"v1ObjectFieldSelector":{"type":"object","properties":{"apiVersion":{"type":"string","title":"Version of the schema the FieldPath is written in terms of, defaults to \"v1\".\n+optional"},"fieldPath":{"type":"string","description":"Path of the field to select in the specified API version."}},"title":"ObjectFieldSelector selects an APIVersioned field of an object.\n+structType=atomic"},"v1ResourceFieldSelector":{"type":"object","properties":{"containerName":{"type":"string","title":"Container name: required for volumes, optional for env vars\n+optional"},"resource":{"type":"string","title":"Required: resource to select"},"divisor":{"$ref":"#/components/schemas/resourceQuantity"}},"title":"ResourceFieldSelector represents container resources (cpu, memory) and their output format\n+structType=atomic"},"v1FCVolumeSource":{"type":"object","properties":{"targetWWNs":{"type":"array","items":{"type":"string"},"title":"targetWWNs is Optional: FC target worldwide names (WWNs)\n+optional\n+listType=atomic"},"lun":{"type":"integer","format":"int32","title":"lun is Optional: FC target lun number\n+optional"},"fsType":{"type":"string","title":"fsType is the filesystem type to mount.\nMust be a filesystem type supported by the host operating system.\nEx. \"ext4\", \"xfs\", \"ntfs\". Implicitly inferred to be \"ext4\" if unspecified.\nTODO: how do we prevent errors in the filesystem from compromising the machine\n+optional"},"readOnly":{"type":"boolean","title":"readOnly is Optional: Defaults to false (read/write). ReadOnly here will force\nthe ReadOnly setting in VolumeMounts.\n+optional"},"wwids":{"type":"array","items":{"type":"string"},"title":"wwids Optional: FC volume world wide identifiers (wwids)\nEither wwids or combination of targetWWNs and lun must be set, but not both simultaneously.\n+optional\n+listType=atomic"}},"description":"Represents a Fibre Channel volume.\nFibre Channel volumes can only be mounted as read/write once.\nFibre Channel volumes support ownership management and SELinux relabeling."},"v1AzureFileVolumeSource":{"type":"object","properties":{"secretName":{"type":"string","title":"secretName is the  name of secret that contains Azure Storage Account Name and Key"},"shareName":{"type":"string","title":"shareName is the azure share Name"},"readOnly":{"type":"boolean","title":"readOnly defaults to false (read/write). ReadOnly here will force\nthe ReadOnly setting in VolumeMounts.\n+optional"}},"description":"AzureFile represents an Azure File Service mount on the host and bind mount to the pod."},"v1ConfigMapVolumeSource":{"type":"object","properties":{"localObjectReference":{"$ref":"#/components/schemas/v1LocalObjectReference"},"items":{"type":"array","items":{"$ref":"#/components/schemas/v1KeyToPath"},"title":"items if unspecified, each key-value pair in the Data field of the referenced\nConfigMap will be projected into the volume as a file whose name is the\nkey and content is the value. If specified, the listed keys will be\nprojected into the specified paths, and unlisted keys will not be\npresent. If a key is specified which is not present in the ConfigMap,\nthe volume setup will error unless it is marked optional. Paths must be\nrelative and may not contain the '..' path or start with '..'.\n+optional\n+listType=atomic"},"defaultMode":{"type":"integer","format":"int32","title":"defaultMode is optional: mode bits used to set permissions on created files by default.\nMust be an octal value between 0000 and 0777 or a decimal value between 0 and 511.\nYAML accepts both octal and decimal values, JSON requires decimal values for mode bits.\nDefaults to 0644.\nDirectories within the path are not affected by this setting.\nThis might be in conflict with other options that affect the file\nmode, like fsGroup, and the result can be other mode bits set.\n+optional"},"optional":{"type":"boolean","title":"optional specify whether the ConfigMap or its keys must be defined\n+optional"}},"description":"Adapts a ConfigMap into a volume.\n\nThe contents of the target ConfigMap's Data field will be presented in a\nvolume as files using the keys in the Data field as the file names, unless\nthe items element is populated with specific mappings of keys to paths.\nConfigMap volumes support ownership management and SELinux relabeling."},"v1VsphereVirtualDiskVolumeSource":{"type":"object","properties":{"volumePath":{"type":"string","title":"volumePath is the path that identifies vSphere volume vmdk"},"fsType":{"type":"string","title":"fsType is filesystem type to mount.\nMust be a filesystem type supported by the host operating system.\nEx. \"ext4\", \"xfs\", \"ntfs\". Implicitly inferred to be \"ext4\" if unspecified.\n+optional"},"storagePolicyName":{"type":"string","title":"storagePolicyName is the storage Policy Based Management (SPBM) profile name.\n+optional"},"storagePolicyID":{"type":"string","title":"storagePolicyID is the storage Policy Based Management (SPBM) profile ID associated with the StoragePolicyName.\n+optional"}},"description":"Represents a vSphere volume resource."},"v1QuobyteVolumeSource":{"type":"object","properties":{"registry":{"type":"string","title":"registry represents a single or multiple Quobyte Registry services\nspecified as a string as host:port pair (multiple entries are separated with commas)\nwhich acts as the central registry for volumes"},"volume":{"type":"string","description":"volume is a string that references an already created Quobyte volume by name."},"readOnly":{"type":"boolean","title":"readOnly here will force the Quobyte volume to be mounted with read-only permissions.\nDefaults to false.\n+optional"},"user":{"type":"string","title":"user to map volume access to\nDefaults to serivceaccount user\n+optional"},"group":{"type":"string","title":"group to map volume access to\nDefault is no group\n+optional"},"tenant":{"type":"string","title":"tenant owning the given Quobyte volume in the Backend\nUsed with dynamically provisioned Quobyte volumes, value is set by the plugin\n+optional"}},"description":"Represents a Quobyte mount that lasts the lifetime of a pod.\nQuobyte volumes do not support ownership management or SELinux relabeling."},"v1AzureDiskVolumeSource":{"type":"object","properties":{"diskName":{"type":"string","title":"diskName is the Name of the data disk in the blob storage"},"diskURI":{"type":"string","title":"diskURI is the URI of data disk in the blob storage"},"cachingMode":{"type":"string","title":"cachingMode is the Host Caching mode: None, Read Only, Read Write.\n+optional\n+default=ref(AzureDataDiskCachingReadWrite)"},"fsType":{"type":"string","title":"fsType is Filesystem type to mount.\nMust be a filesystem type supported by the host operating system.\nEx. \"ext4\", \"xfs\", \"ntfs\". Implicitly inferred to be \"ext4\" if unspecified.\n+optional\n+default=\"ext4\""},"readOnly":{"type":"boolean","title":"readOnly Defaults to false (read/write). ReadOnly here will force\nthe ReadOnly setting in VolumeMounts.\n+optional\n+default=false"},"kind":{"type":"string","title":"kind expected values are Shared: multiple blob disks per storage account  Dedicated: single blob disk per storage account  Managed: azure managed data disk (only in managed availability set). defaults to shared\n+default=ref(AzureSharedBlobDisk)"}},"description":"AzureDisk represents an Azure Data Disk mount on the host and bind mount to the pod."},"v1PhotonPersistentDiskVolumeSource":{"type":"object","properties":{"pdID":{"type":"string","title":"pdID is the ID that identifies Photon Controller persistent disk"},"fsType":{"type":"string","description":"fsType is the filesystem type to mount.\nMust be a filesystem type supported by the host operating system.\nEx. \"ext4\", \"xfs\", \"ntfs\". Implicitly inferred to be \"ext4\" if unspecified."}},"description":"Represents a Photon Controller persistent disk resource."},"v1ProjectedVolumeSource":{"type":"object","properties":{"sources":{"type":"array","items":{"$ref":"#/components/schemas/v1VolumeProjection"},"title":"sources is the list of volume projections. Each entry in this list\nhandles one source.\n+optional\n+listType=atomic"},"defaultMode":{"type":"integer","format":"int32","title":"defaultMode are the mode bits used to set permissions on created files by default.\nMust be an octal value between 0000 and 0777 or a decimal value between 0 and 511.\nYAML accepts both octal and decimal values, JSON requires decimal values for mode bits.\nDirectories within the path are not affected by this setting.\nThis might be in conflict with other options that affect the file\nmode, like fsGroup, and the result can be other mode bits set.\n+optional"}},"title":"Represents a projected volume source"},"v1VolumeProjection":{"type":"object","properties":{"secret":{"$ref":"#/components/schemas/v1SecretProjection"},"downwardAPI":{"$ref":"#/components/schemas/v1DownwardAPIProjection"},"configMap":{"$ref":"#/components/schemas/v1ConfigMapProjection"},"serviceAccountToken":{"$ref":"#/components/schemas/v1ServiceAccountTokenProjection"},"clusterTrustBundle":{"$ref":"#/components/schemas/v1ClusterTrustBundleProjection"},"podCertificate":{"$ref":"#/components/schemas/v1PodCertificateProjection"}},"description":"Projection that may be projected along with other supported volume types.\nExactly one of these fields must be set."},"v1SecretProjection":{"type":"object","properties":{"localObjectReference":{"$ref":"#/components/schemas/v1LocalObjectReference"},"items":{"type":"array","items":{"$ref":"#/components/schemas/v1KeyToPath"},"title":"items if unspecified, each key-value pair in the Data field of the referenced\nSecret will be projected into the volume as a file whose name is the\nkey and content is the value. If specified, the listed keys will be\nprojected into the specified paths, and unlisted keys will not be\npresent. If a key is specified which is not present in the Secret,\nthe volume setup will error unless it is marked optional. Paths must be\nrelative and may not contain the '..' path or start with '..'.\n+optional\n+listType=atomic"},"optional":{"type":"boolean","title":"optional field specify whether the Secret or its key must be defined\n+optional"}},"description":"Adapts a secret into a projected volume.\n\nThe contents of the target Secret's Data field will be presented in a\nprojected volume as files using the keys in the Data field as the file names.\nNote that this is identical to a secret volume source without the default\nmode."},"v1DownwardAPIProjection":{"type":"object","properties":{"items":{"type":"array","items":{"$ref":"#/components/schemas/v1DownwardAPIVolumeFile"},"title":"Items is a list of DownwardAPIVolume file\n+optional\n+listType=atomic"}},"description":"Represents downward API info for projecting into a projected volume.\nNote that this is identical to a downwardAPI volume source without the default\nmode."},"v1ConfigMapProjection":{"type":"object","properties":{"localObjectReference":{"$ref":"#/components/schemas/v1LocalObjectReference"},"items":{"type":"array","items":{"$ref":"#/components/schemas/v1KeyToPath"},"title":"items if unspecified, each key-value pair in the Data field of the referenced\nConfigMap will be projected into the volume as a file whose name is the\nkey and content is the value. If specified, the listed keys will be\nprojected into the specified paths, and unlisted keys will not be\npresent. If a key is specified which is not present in the ConfigMap,\nthe volume setup will error unless it is marked optional. Paths must be\nrelative and may not contain the '..' path or start with '..'.\n+optional\n+listType=atomic"},"optional":{"type":"boolean","title":"optional specify whether the ConfigMap or its keys must be defined\n+optional"}},"description":"Adapts a ConfigMap into a projected volume.\n\nThe contents of the target ConfigMap's Data field will be presented in a\nprojected volume as files using the keys in the Data field as the file names,\nunless the items element is populated with specific mappings of keys to paths.\nNote that this is identical to a configmap volume source without the default\nmode."},"v1ServiceAccountTokenProjection":{"type":"object","properties":{"audience":{"type":"string","title":"audience is the intended audience of the token. A recipient of a token\nmust identify itself with an identifier specified in the audience of the\ntoken, and otherwise should reject the token. The audience defaults to the\nidentifier of the apiserver.\n+optional"},"expirationSeconds":{"type":"string","format":"int64","title":"expirationSeconds is the requested duration of validity of the service\naccount token. As the token approaches expiration, the kubelet volume\nplugin will proactively rotate the service account token. The kubelet will\nstart trying to rotate the token if the token is older than 80 percent of\nits time to live or if the token is older than 24 hours.Defaults to 1 hour\nand must be at least 10 minutes.\n+optional"},"path":{"type":"string","description":"path is the path relative to the mount point of the file to project the\ntoken into."}},"description":"ServiceAccountTokenProjection represents a projected service account token\nvolume. This projection can be used to insert a service account token into\nthe pods runtime filesystem for use against APIs (Kubernetes API Server or\notherwise)."},"v1ClusterTrustBundleProjection":{"type":"object","properties":{"name":{"type":"string","title":"Select a single ClusterTrustBundle by object name.  Mutually-exclusive\nwith signerName and labelSelector.\n+optional"},"signerName":{"type":"string","title":"Select all ClusterTrustBundles that match this signer name.\nMutually-exclusive with name.  The contents of all selected\nClusterTrustBundles will be unified and deduplicated.\n+optional"},"labelSelector":{"$ref":"#/components/schemas/v1LabelSelector"},"optional":{"type":"boolean","title":"If true, don't block pod startup if the referenced ClusterTrustBundle(s)\naren't available.  If using name, then the named ClusterTrustBundle is\nallowed not to exist.  If using signerName, then the combination of\nsignerName and labelSelector is allowed to match zero\nClusterTrustBundles.\n+optional"},"path":{"type":"string","description":"Relative path from the volume root to write the bundle."}},"description":"ClusterTrustBundleProjection describes how to select a set of\nClusterTrustBundle objects and project their contents into the pod\nfilesystem."},"v1PodCertificateProjection":{"type":"object","properties":{"signerName":{"type":"string","description":"Kubelet's generated CSRs will be addressed to this signer.\n\n+required"},"keyType":{"type":"string","description":"The type of keypair Kubelet will generate for the pod.\n\nValid values are \"RSA3072\", \"RSA4096\", \"ECDSAP256\", \"ECDSAP384\",\n\"ECDSAP521\", and \"ED25519\".\n\n+required"},"maxExpirationSeconds":{"type":"integer","format":"int32","description":"maxExpirationSeconds is the maximum lifetime permitted for the\ncertificate.\n\nKubelet copies this value verbatim into the PodCertificateRequests it\ngenerates for this projection.\n\nIf omitted, kube-apiserver will set it to 86400(24 hours). kube-apiserver\nwill reject values shorter than 3600 (1 hour).  The maximum allowable\nvalue is 7862400 (91 days).\n\nThe signer implementation is then free to issue a certificate with any\nlifetime *shorter* than MaxExpirationSeconds, but no shorter than 3600\nseconds (1 hour).  This constraint is enforced by kube-apiserver.\n`kubernetes.io` signers will never issue certificates with a lifetime\nlonger than 24 hours.\n\n+optional"},"credentialBundlePath":{"type":"string","description":"Write the credential bundle at this path in the projected volume.\n\nThe credential bundle is a single file that contains multiple PEM blocks.\nThe first PEM block is a PRIVATE KEY block, containing a PKCS#8 private\nkey.\n\nThe remaining blocks are CERTIFICATE blocks, conta
[...]
